"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flattenDependencies = flattenDependencies;
exports.flattenDependencyIds = flattenDependencyIds;

function _utils() {
  const data = require("../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function flattenDependencies(dependencies) {
  return Object.values((0, _utils().flatten)(dependencies.map(dep => dep.allDependencies.concat(dep.component))).reduce((components, component) => {
    components[component.id.toString()] = component;
    return components;
  }, {}));
}

function flattenDependencyIds(dependencies, repo) {
  return Promise.all(dependencies.map(dep => {
    const depCompId = dep.component.id.changeScope(dep.sourceScope);
    return dep.component.flattenedDependencies(repo).then(flattenedDeps => flattenedDeps.concat(depCompId));
  })).then(idMatrix => {
    const ids = (0, _utils().flatten)(idMatrix);
    return Object.values(ids.reduce((components, id) => {
      components[id.toString()] = id;
      return components;
    }, {}));
  });
}